import React, {useState, useEffect, useRef} from 'react'

import { connect } from 'react-redux'

import { CMsg, MsgMenu } from '.'

const msgsWrapper = {
   display: "flex",
   flexDirection: "column-reverse",
   justifyContent: "flex-start",
   alignItems: "stretch",
   paddingTop: "10px",
   paddingBottom: "5px"
}

const MsgList = ({chats={}, chatId }) => {

   const prevOwner = useRef('')
   const prevTime = useRef('')

   useEffect(() => {
      prevOwner.current = ''
      prevTime.current = ''
   })

   // надо ли писать реф?
   const msgArr = chats[chatId]?.messages

   return (
      <div 
         style={msgsWrapper}
         >
         { msgArr ?

            msgArr.map(msg => <CMsg               
                                 key={msg._id} 
                                 msg={msg} 
                                 prevOwner={prevOwner}
                                 prevTime={prevTime}
                               />) :
               
                     <div>сообщений нема</div>         
         }  

      </div>
   )
}
export const CMsgList = connect(state => ( { chats: state.chats } ))(MsgList)



