import React from 'react';
import ListItem from '@mui/material/ListItem';
import Divider from '@mui/material/Divider';
import ListItemText from '@mui/material/ListItemText';
import ListItemAvatar from '@mui/material/ListItemAvatar';

import { UserAvatar } from '.'



export const UserCard= ({ user, render, onAction, disabled=false }) => {

   const ManageBtn = render
   return (
      <>
         <ListItem
            sx={ disabled ? { bgcolor: '#ddd' } : {} }
            secondaryAction={
               disabled ?
               <></> :
               <ManageBtn onEvent={onAction} />
            }
            >

            <ListItemAvatar>
               <UserAvatar profile={user} />
            </ListItemAvatar>

            <ListItemText
               primary={user.login}
               secondary={user.nick}
            />
         </ListItem>
      <Divider variant="inset" component="li" />
     </>
   )
 }
