import React, {useState, useEffect, useRef} from 'react';

import { connect }  from 'react-redux'
import {
  actionFullChatList,
  actionChatsCount,
} from "../actions"

import { CChatList } from '../components'

// TODO: разобраться откуда берется оверфлоу по X
const chatsPage= {
   height: "calc(100vh - 60px)",
   maxWidth: "100%",
   overflowY: "auto",
   overflowX: "hidden",
 }

const ChatsPage = ({  match:{params:{_id}}, auth, 
                      getChats, chatsCount=20, 
                      allCount, getAllCount, }) => {

   const [chatBlock, setChatBlock] = useState(0)
   const [count, setCount] = useState(allCount)

 
   useEffect(async () => {
     const userId = auth.payload?.sub?.id 
     if (userId) {
      await getChats(userId, chatBlock, chatsCount)

      // CHECK: правильно ли тут написано?
      let res = await getAllCount(userId)
      setCount(res)
     } 
    //  console.log(chatBlock, count)

     return function cleanUp() {
     }
   },[chatBlock])
 
   return (
     <div 
       style={chatsPage}
       onScroll={(e) => {
         if (chatBlock < count) {

            if (e.target.scrollTop >= e.target.scrollHeight - e.target.clientHeight) {
              setChatBlock(chatBlock => chatBlock + chatsCount)
            }
         }
       }}
       >

         <CChatList currChatId={_id} />

     </div>
   )
 }
 export const CChatsPage= connect( state => ( { auth: state.auth, 
                                                allCount: state.promise?.chatsCount?.payload || 0 }),
                                              { getChats: actionFullChatList,
                                                getAllCount: actionChatsCount
                                                    })(ChatsPage)