import React, {useState, useEffect, useRef} from 'react';

import {
   Header, 
   CChatMngHeader,
   CMsgList,
   CSendingField,   
} from "../components"

import {
   actionFullMsgsByChat
 } from "../actions"
 import { connect } from 'react-redux'



const msgPageContainer = {
   backgroundColor: '#eee',
   height: "100vh",
   width: "100%"
}
const msgPageHeader = {
   height: "60px"
}
const msgPageBody = {
   height: "calc(100vh - 60px)",
   display: "flex",
   flexDirection: "column",
   justifyContent: "space-between"
}

const msgs = {
   flexGrow: 1,
   overflowY: "auto",
   display: "flex",
   flexDirection: "column-reverse",
}
const msgSend = {
   flexGrow: 0,
   height: "max-content",
   maxHeight: "60%",
}

const MsgBlock = ({ chatId, getMsgs, msgsCount=20 }) => {

   const [msgsBlock, setMsgsBlock] = useState(1)

   // перезагрузка и обновление стейта происходит тут ??????????
   // надо как то отлавливать первый не первый рендер ????????

   useEffect(() => {
      getMsgs(chatId, msgsBlock, msgsCount)
   },[msgsBlock])

   return (
      <>  
         <div style={msgPageContainer}>

            <div style={msgPageHeader}>
               <Header> 

                  <CChatMngHeader chatId={chatId} />

               </Header>  
            </div>

            <div style={msgPageBody}>

               <div 
                  style={msgs}
                  onScroll={(e) => {
                     if (e.target.scrollTop*(-1) >= e.target.scrollHeight - e.target.clientHeight) {
                        setMsgsBlock(msgsBlock => msgsBlock + msgsCount)
                     }
                  }}
                  >
                  <CMsgList chatId={chatId} />
               </div>

               <div style={msgSend}>
                  <CSendingField chatId={chatId} />
               </div>       

            </div>

         </div>              
      </>
   )
}
const CMsgBlock = connect( null, {getMsgs: actionFullMsgsByChat})(MsgBlock)

export const MsgPage = ({ match:{params:{_id}} }) => (
   <>
      <CMsgBlock chatId={_id} key={_id} />
   </>
)