
// const chats = {
//   chats: [ 
//     {_id: '333', title: 'moiChat2', avatar: null, lastModified: 'segodnya', owner: {login: 'ya'}, members:[]},
//     {_id: '222', title: 'moiChat', avatar: null, lastModified: 'vchera', owner: {login: 'ya'}, members:[]}
//   ],
//   messages: {
//     '222': [
//       {text: 'uuu'}, {text: 'uuuuuu'}
//     ],
//     '333': [
//       {text: 'UUU'}, {text: 'U'}
//     ]
//   }
// }

// payload - или массив чатов или массив сообщений или 1 чат
 export function chatsReducer (state={}, {type, payload}) {
    if (!state) {
        return {}
    }
    
    function refreshMsgs(newMsgs, oldMsgs) {
      const msgState = oldMsgs

      for (const newMsg of newMsgs || []) {   
        const currIndex = msgState.findIndex(oldMsg => oldMsg._id === newMsg._id)

        if (currIndex === -1) {
          msgState.push(newMsg)                
        } else {
          msgState[currIndex] = newMsg
        }
      }

      const newMsgState = msgState.sort((a, b) => {
        if (a._id > b._id) {
          return -1
        }
        if (a._id < b._id) {
          return 1
        }
        return 0
      })

      return newMsgState
    }

    // перебрать, проверить, что везде есть ключи, если где то нет, использовать те что есть
    // function refreshMembers(newMembers, oldMembers) {
    // }


    function sortChats(unsortedChats) {
      return Object.fromEntries(
        Object.entries(unsortedChats).sort((a, b) => {
          if (a[1].lastModified > b[1].lastModified) {                
            return -1
          }
          if (a[1].lastModified < b[1].lastModified) {
            return 1
          }
          return 0
        })
      )
    }

    const types = {
      // BUG: иногда часть чатов пропадают из стора, причины не до конца понятны
      // конкретный триггер пока не обнаружен, по идее в их id как то попадает undefined
      CHATS() {
        if (payload) {

          const oldChats = {...state}

          // перебираем новые чаты
          for (const chat of payload) {
            // находим старый чат с ид нового
            const oldChat = oldChats[chat._id]
            // если его еще нет, то просто записываем
            if (!oldChat) {
              oldChats[chat._id] = chat //-----------------------------------------
              // если есть, то идем по свойствам нового чата
            } else for (const key in chat) {
              // записываем значение свойства нового и старого чата 
              const oldValue = oldChat[key]
              const newValue = chat[key]
              // проверяем наличие значений
              // если оба значения есть, переходим к проверке на массив (на объект вроде не надо)
              if (oldValue && newValue) {
                // если массив, то выясняем какой и вызываем соответствующие функции слияния
                if (Array.isArray(newValue)) {
                  if (key === 'messages') {
                    oldChats[chat._id][key] = refreshMsgs(newValue, oldValue)
                  }
                  if (key === 'members') {
                    oldChats[chat._id][key] = newValue
                  }
                  // если не массив, то перезаписываем новым значением
                } else {
                  oldChats[chat._id][key] = newValue //-----------------------------------
                }

                // если есть только новое, записать новое
              } else if (newValue) {
                oldChats[chat._id][key] = newValue //-------------------------------------
                // если есть только старое, записать старое (можно ничего не делать)
              } else {
                oldChats[chat._id][key] = oldValue //-------------------------------------
              }
            }

          }
          
          const newState = sortChats(oldChats)

          // console.log(newState, 'dasdasdasdasd')
          return newState
        }
        return state
      },

      CHAT_LEFT() {   
        const { [payload._id]: removed, ...newState }  = state        
        return newState
      },

      MSGS() {
        if (payload && payload.length > 0) {
        
          const chatId = payload[0]?.chat?._id

          const msgState = state[chatId]?.messages || []
          
          const newMsgState = refreshMsgs(payload, msgState)

          const newState = {
            ...state,
            [chatId]: {
              ...state[chatId],
              messages: newMsgState
            }
          }

          return newState
        }
        return state
      }

    }
    if (type in types) {        
        return types[type]()
    }
    return state
 }

  export const actionChatList = (chats) => (
        {type: 'CHATS', payload: chats}
  )     
  export const actionChatOne = (chat) => (
        {type: 'CHATS', payload: [chat]}
  )
  export const actionChatLeft = (chat) => (
        {type: 'CHAT_LEFT', payload: chat}
  )

  // добавить id чата ?
  export const actionMsgList = (msgs) => (
        {type: 'MSGS', payload: msgs}
  )
  export const actionMsgOne = (msg) => (
        {type: 'MSGS', payload: [msg]}
  )
      








